#include <iostream>
#include <cmath>
#include "common.h"

using namespace std;
using namespace cmmn;

int main(){
	while (true) {
	L1:	cout << "p(%) = ";
		cin >> p;
		if (p <= 0.0) break;
		if ((p < 50.0) || (100.0 <= p)){
			goto L1;
		}
	L2:	pa = (100.0 - p)/100.0;
		cout << "N = ";
		cin >> N;
		if (N < 1){
			goto L2;
		}
	L3:	cout << "k = ";
		cin >> k;
		if ((k < 0) || (k > N)){
			goto L3;
		}
		LogCombi = new long double[N+1];
		for (int i = 0; i <= N; i++){
			if ((i == 0) || (i == N)) LogCombi[i] = 0.0;
			else {
				long double v = 0.0;
				for (int j = i; j >= 1; j--)
					v += log(N + 1.0 - j) - log( j );
				LogCombi[i] = v;
			}
		}

		long double LB, UB;
		try{
			if (UCum_prob(0.0) > (pa/2.0)){
				LB = 0.0; 
				Bisection( Cum_prob, -1.0, pa/2.0, 0.0, 1.0, UB, 1.0e-9 );
			}else{
				if (Cum_prob(1.0) > (pa/2.0)){
					UB = 1.0;
					Bisection( UCum_prob, 1.0, pa/2.0, 0.0, 1.0, LB, 1.0e-9 );
				}else{
					Bisection( Cum_prob, -1.0, pa/2.0, 0.0, 1.0, UB, 1.0e-9 );
					Bisection( UCum_prob, 1.0, pa/2.0, 0.0, 1.0, LB, 1.0e-9 );
				}
			}
			cout << p << "% Interval[" << LB << ", " << UB << "]" << endl;
		}
		catch (char const * e){
			cout << "Error-> " << e << endl;
		}

		delete [] LogCombi;
	}

	return 0;
}

