#ifndef COMMON_CK
#define COMMON_Ck

namespace cmmn {

	extern long double p, pa;

	extern int N, k;

	extern long double * LogCombi;


	//     Bisection  
	void Bisection( long double (*f)(long double),
			  long double s,			//  f is increasing -> s > 0.0
								//  f is decreasing -> s < 0.0
			  long double c,			//  f(Root) = c
			  long double L_b, 			//  L_b < Root < U_b
			  long double U_b,	
			  long double & Root,		//  Set Root so that f(Root) = c
			  long double acc );			//  accuracy


	long double prob_term( long double p, int N, int i );

	long double Cum_prob( long double p );


	long double UCum_prob( long double p );

}

#endif
